% plot(varargin)  plots a SP.signal object for plot options see the help 
%   of the MATLAB plot function
%
%   plot(signal, plotoptions);
%   signal.plot(plotoptions);
%
%--------------------------------------------------------------------------
% Copyright (c) 2014, Florian Heese
% Institute of Communication Systems and Data Processing
% RWTH Aachen University, Germany
% Contact information: heese@ind.rwth-aachen.de
%
% All rights reserved.
%
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are
% met:
%
%    * Redistributions of source code must retain the above copyright
%      notice, this list of conditions and the following disclaimer.
%    * Redistributions in binary form must reproduce the above copyright
%      notice, this list of conditions and the following disclaimer in
%      the documentation and/or other materials provided with the 
%      distribution
%    * Neither the name of the RWTH Aachen University nor the names
%      of its contributors may be used to endorse or promote products 
%      derived from this software without specific prior written 
%      permission.
%
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
% "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
% LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
% PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
% OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
% EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
% PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
% PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
% LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
% NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
% SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
%--------------------------------------------------------------------------
function plot( this, varargin)

    x = linspace(0,this.signalLength,this.signalSamples);

    if nargin == 1 % offset caused by 'this'
       plot(x, this.to_double)
    elseif nargin == 2
       plot(x, this.to_double, varargin{1} )
    elseif mod(nargin - 1 ,2) == 0
       set(plot(x, this.to_double), varargin{1:2:end}, ...
          varargin{2:2:end});
    elseif mod(nargin - 1, 2) == 1
       set(plot(x, this.to_double, varargin{1}) , varargin{2:2:end} ...
          , varargin{3:2:end});
    end

    xlabel('Time in [s]')
    ylabel('Amplitude')
    title(['Waveform: ' this.sourceName], 'Interpreter','none')
    axis([x(1) x(end) -1 1]);
    
end

